﻿using System.Collections.Generic;
using Luticate2.Utils.Dbo;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.SignalR.Infrastructure;

namespace Luticate2.Utils.Controllers
{
    public abstract class LuController : Controller
    {
        protected IConnectionManager ConnectionManager { get; set; }

        protected IDictionary<object, object> LuItems => HttpContext.GetLuItems();

        protected T Handle<T>(LuResult<T> result)
        {
            if (result)
            {
                return result.Data;
            }
            return default(T);//TODO
        }
    }
}