﻿using System;
using Luticate2.Auth.DataAccess;

namespace Test.Auth
{
    public class Tests
    {
        public static LuDatabaseContext GetDataBaseContext()
        {
            return
                new LuDatabaseContext(
                    "User ID=dev;Password=dev;Host=localhost;Port=5432;Database=luticate2;Pooling=true;");
        }

        public static void TestRealDb(Action<LuDatabaseContext> func)
        {
            var dbContext = GetDataBaseContext();
            dbContext.Database.BeginTransaction();
            func(dbContext);
            dbContext.Database.RollbackTransaction();
        }
    }
}